TODO 'Bookkeeping'

1 > synchronise database access 
	[OK] Working SingleThreadModel servlet. 
	[OK] Later make the servlet requests threaded and read/write lock on the DB code. 
		Also the SingleThreadModel is deprecated to be discontinued after 2.4. 
	
	- test to ensure that simultaneous servlet updates are executed 1 at a time; 
	which testbench to use that tests mutiple threads and performance? 
		
		* cactus; http://jakarta.apache.org/cactus
		- give initial state; 'bookkeeping.2.system.xml' 
		- give 2 data to add / update 
			- system should fill in entry and debit/credit ids. 
			- client must specify the correct journalid in the entry; an incorrect journalid should give an error 
			<journal:entry id="" entrynum="" state="" journalid="" date="">
			<account:debit id="" amount="50.00" entryid="" accountid="1" account="office equipment"/>
			<account:credit id="" amount="50.00" entryid="" accountid="3" account="bank"/>
			</journal:entry>
			
			<journal:entry id="" entrynum="" state="" journalid="" date="">
			<account:debit id="" amount="70.00" entryid="" accountid="1" account="office equipment"/>
			<account:credit id="" amount="70.00" entryid="1" accountid="3" account="bank"/>
			</journal:entry>
		
		- ensure BookkeepingSystem MODEL is reloaded

4 > ** code for collecting monies 
	- from donation, paid accounts
	- via PayPal / Credit Cards (Authorize.net)
	- design data structure / code that understands the difference between paid and unpaid accounts 

5 > What functionalities go with a paid account 
	- income statements 
	- balance sheets 
	
	- ability to import / export data 
	- import / export <==> oe.quickbooks.com, mint.com, freshbooks.com
	
	- bank reconciliation (bank, etrade, visa, american express)
	- bill reconciliation 
	
	- create / track invoices 
	- manage payroll 
6 > 	Attach data that represent  physical records of an entry - images, pdfs , doc, rtf 
7 > 	Schedule a time for the application to record an expense 



>>>>>>>>>>>>>>>>>>>> MARKETING
-- selling 
	- define product; ( easily organise your financial records from anywhere in the world ) 
	
	- define market for online bookkeeping ( small businesses, entrepreneurs, accounting & bookkeeping firms ); 
		- what bookkeeping problems are these clients having? ( forums: www.proseries.com )
		- what would make thier life easier? 
		** find accountants (accounting firm) to use / improve the product 
		
	- define competition ( Quickbooks Online Edition, www.netsuite.com, ... ); 
		- where and how they are selling ( boring and tedious web ads ) 
		- check out bookkeeping software
			http://freshmeat.net/projects/dolphacct/

		-> Quickbooks Online Edition
		-> netsuite.com 
		-> mint.com 
		-> freshbooks.com
		
	- pricing; 
		- free basic account; 5 accounts and 1 journal 
		- $5 / month for unlimited accounts & journals 
	
	- promoting
		- launch / presskit 
		- tools to tell friends 
		- consult with a good marketing person 


>>>>>>>>>>>>>>>>>>>> LATER 
	
-- XQuery / XPath
	** commit semantics are a mess, use XPath / XQuery to find, save XML data 

-- put 'notes' into the entry and debit/credit tokens 
		var/value 

-- XQuery script to create XML:DB collection structure 

-- loaded bob can update/augment data structure by calling a load method on itself (will require some redesisgn) 


** in 'bkeeping' ExpressionVisitor put add and remove in commands (now using the visitors) 
** in FindCommand, use the new com.interrupt.bookkeeping.cc.bkell.command.FindVisitor for a list of possible results 

-- unit tests for save, load, delete, update 
-- refactor 
	i. BookkeepingServlet 
	ii. TestPersistence.testBobRetrieve

	
-- 'Bob' support for xpath, xpointer, xquery, xupdate 

-- DATA EXCHANGE 
    -> exporting to excel is the best way; try ( http://jakarta.apache.org/poi/ )
    -> other major accounting softw.:
	[OK] QuickBooks, (et. al. accounting softw.); 
	    * import/export excel
	    - uses a bloated, proprietary file format
	[OK] MYOB; 
	    * import/export excel
	[x] Peachtree Bookkeeping
	    - doesn't import data
	[OK] Simply Accounting; 
	    * export excel

-- WORKFLOW; write a simple workflow system
    ? based on PNML (Petri Net Markup Language)
    [x] 'bossa' does not enough documentation
    - needed for when objects should be: 
    1) persisted when a transaction is CLOSED
    2) interact with UI

    [OK] write up a simple petri net diagram for
	i) processing transaction (after adding many journal entries)

    [x] rakiura-jfern-3.0.0
	- designed to accomodate already built petri-net engines
    
    Bossa can read the PNML files created by the Petri Net Kernel editor. 
	bossa-pnk-0.1.tar.gz

-- have a 'fitnesse' wiki to track
	- functionality
	- project velocity

>>>>>>>>>>>>>>>>>>>> SELLING
	
Double-Entry Bookkeeping, meaning debit and credit Journal entries. This means that the software can track debit / credit accounts. So the user can use 'Bookkeeping' to maintain income, expense, asset, liability and capital accounts. 
	
	
    - Platform Independent; Windows, Linux, OS X 
    
	- Adding Journal Entries 
    - Reversing Journal entries
    - Deleting Journal entries
    - Easier Finding / Viewing / Ordering of Journal entries
	
	- Preparing Taxes ( Canada, US, UK ) 
	
	
    - Exchange data with 
	QuickBooks, ( .QIF file format )
	Quicken ( .IIF file format )
	MYOB
	Peachtree Bookkeeping
	Simply Accounting
	[NEW; all linux packages] SQL Ledger(http://www.sql-ledger.org/), GNUCash(), KMyMoney2() 
	
	
    - generating general ledgers for configured time periods ( Fiscal year )
    - generating income and balance statements
    - generating tax statements at the end of the tax year.
    
    - Bank Reconciliation
    - Trial Balances
    - Year End
	
    ? invoice printer
    ? cheque printer
    

>>>>>>>>>>>>>>>>>>>> ISSUES
	
	- when closing an entry through a <transaction/>, there is currently not a way to guarantee that
	  each entry balances, before the transaction adds those entries to the corresponding <journal/>
	
	  
    - how to exchange data with QuickBooks, (et. al. accounting softw.)
	-> All transactions are easily exportable to other programs as standard tab-delimited text files
	
    - how to do Bank Reconciliation
    
    - can Flash be the desktop UI? (can laszlo UI generate desktop windows)
    
    - generating general ledgers for configured time periods
    - generating income and balance statements
    - generating tax statements at the end of the tax year.
    
    - sort journal entries by... date, alphabet, etc
    - reversing entries
	- or deleting entries
    
    * see also 'bookkeeping.xml' and 'system.xml' for notes 
    system architecture
    * initially, there is 1 general journal

	** had to build a custom version of sablecc-anttask to get it to generate my classes
	
    
    
>>>>>>>>>>>>>>>>>>>> TECHNOLOGY lookups
[OK] persistence
[x] JDO vs. Hibernate vs. XML Database
Neither JDO, nor Hibernate provide full native XML persistence. However, hibernate has a feature that aims to map xml documents to DB data. 

	[x] Hibernate (for Obj/DB persistence)
	[x] JDO
	[OK] XML Database
	    http://www.rpbourret.com/xml/XMLAndDatabases.htm
	    http://www.rpbourret.com/xml/XMLDatabaseProds.htm#native
	    http://www.cse.iitk.ac.in/report-repository/2004/Y1043.pdf
	    XML:DB; native xml database ()
	    [OK] eXist 
		- http://exist.sourceforge.net/api/index.html
	    XQuery (http://www.w3.org/XML/Query)
	    XPath ()
    [OK] workflow (to handle states of objects throughout different types of a process)
	Bossa

    [x] searching
	[x] Lucene (for text search)
	
    [OK]commons-cli
    [OK]velocity
    [OK]javafind


>>>>>>>>>>>>>>>>>>>> COMPLETED 
[DONE] idgenerator 
    - try (java.rmi.dgc.VMID)
[DONE] debits and credits for all accounts
[DONE] list of accounts are always maintained by the system and persisted
[DONE] generate 'objectid'; for example, 'entrynum' for each entry
[DONE] each object in the system should have an id
    
    [DONE] double entry bookkeeping
	[DONE] debits equal credits for 1 transaction
	[DONE] each debit/credit goes to an account
	    ** 'CloseAction' puts into correct account. make this
	    [DONE] make transaction/entry close() process separate from class (visitor)
	    [DONE] create 'Accounts' object/subsystem

	[DONE] all transactions balance 
	[DONE] all accounts balance after transaction
	    [NOTE] a 'CLOSE' state
	    ** create 'Balance' objects

    [DONE] ACCOUNT types
	[DONE] income, expense, asset, liability and capital accounts
	[later] a banking institution's books
[OK] find MAILING LIST to introduce bookkeeping; xml-dev (http://lists.xml.org/archives/xml-dev/)

[x] debits / credits should be in 1 place. 
    [OK] Leave them in <journal:entry/> and <account:account/> looks through all journals
	[x] after time jounal entry list will get big
    [OK] Keep <journal:entry/> <account:account/> division
	[x] must constantly resolve debits / credits in <account:account/> with <journal:entry/>
    

[OK] a UI
    -> Laszlo (www.laszlosystems.org); can deploy laszlo Java servlet engine
    -> XUL (http://www.mozilla.org/projects/xul/)
    - view journal entries
    - sort journal entries
    
    [OK] make debit/credit input component
    [OK] make + / - buttons
    [OK] make cancel / save buttons
    [OK] open / close operations & Window workflow; incl. dbl-click & window popup
    - add / remove operations (addNode,deleteNode)
	- on Accounts, Journals & Entries
	
	... howto
	-> generate IDs
	-> maintain 'namespace'
	-> generate 'entrynums'
	-> match date format w/ Java date format
	
    - grid vertical & horizontal bounding
    - preselect 'account' drop down (Account, Entry)
    - put Application into 'Jetty'
    - cleanup hardcoded values
    

[OK] native XML DATABASE 
    [x] Hibernate
	- xml / relational mapping too messy
    [x] JDO
	- default implementation does not map to xml datastore
    [x] Hibernate [native xml]
    [x] JDO [native xml]
    
    [x] Prevaler; object Prevalence for Java
    [OK] eXist DB
	- xmldb:exist://localhost:8080/exist/xmlrpc
	
	[OK] need examples of <journal:entry />
	[OK] make a java program to connects to database
	[OK] adding / retrieving xml from DB
	
	[OK] adding journal entries
	[OK] retrieving journal entries
	[OK] updating entries ( affected by any reversals )
4) reversing entries
5) deleting entries
6) updating account data ( affected by <journal:entry /> )

	[OK] ?? How to maintain the relationships between xml nodes
	[OK] don't maintain relationships; let application do that.
	    -> just store <xml/>
	
	[OK] ?? Should journal entries be 
	[OK] separate documents
	    ii) all in 1 document
	
	[OK] ?? is an XML:DB collection also a document
	    - no

[DONE] ANT
    [DONE] only 'run-gen' if there is no created files
    [DONE] fix classpath referencing

[DONE] figure out a way to have an implicit way to set 'counterWeight' ( bookkeeping.system.xml )

[DONE] split -def / -sys (Bob)
[DONE] need a cleaner way to access handler input values ( Bob; bob.system.xml )

[DONE] create Users, Authentication & Authorization


[DONE] -- FEATURES
    [OK] close an entry
    [OK] close a set of entries ( transaction )
    
    [OK] remove an entry
    [OK] reverse an entry
    
    [OK] find entry
    	[OK] by id 
		[OK] by a date 	// MM/dd/yyyy HH:mm:ss z
		
	[OK] list entry 
		[OK] before and after date 
	
	- add / find / remove <Journals/> 
	- add / find / remove <Accounts/> 


[DONE] do not make 'Accounts' a singleton; 
	[DONE] make <Accounts/> and <Journals/> 1 entity per <bookkeeping/> (root) node. 
	[DONE] refactor 
		TestActions, TestGeneral, TestTransaction / Entry, Transaction 


[DONE]	XML:DB
	[OK] scheme for naming xml docs inside eXist
	[OK] specify toXML depth in Bob
	[OK] prefix namespace in Bob.toXML()
	
	[OK] loading 'Bookkeeping' from XML data store 
	[OK] saving 'Bookkeeping' to XML data store 
	[OK] updating 
	[OK] deleting 
	
	[OK] Strategy for dividing <bookkeeping/> XML into separate pieces
		I think Accounts, Journals, and Transactions should be in 
		separate documents, per user -> this has been achieved in the XML
	
	[OK] Strategy for CRUDing XML w/ native XML database 'eXist'
		- for now, the UI and 'Bob' model will talk to each other. 
		- There will be a commit method for changed nodes after a command has been run.


[DONE] finish 'reverse' command 
	[OK] this involves i) changing the ReverseCommand to set the receiver token's parent <entries/>
	[OK] 'entries' is a new token in the system 


[DONE] variables; (this feature of course ties b'keeping to 'bkell'; loading/saving to 'XML:DB'; and XML to 'Bob' )
	- variables [are NOT loosely typed] a variable can be XML
	- automatic variable is the result of the last command run
	- @variableName can be assigned to i) the last run command or ii) as the result of an expression 
	[OK] define variable syntax 
	[OK] Expression visitor gets/sets variables in command shell (bkell)


[DONE]  put 'account' attribute in debit/credit 
	- now adding entrie tries to use the 'accountid', then the 'account' attributes of the <debit/> and <credit/> tags 


[DONE] Bookkeeping 'Shell' & 'Command Set' for executing functionality 
	[OK] go through all usage scenarios for using 'Bookkeeping' 
	[OK] design little grammar for 'Bookkeeping' 
	-- implement grammar 


[DONE] 'print' command ( for variables ) 

[DONE] finish commit command 
	-- variable names with same name should overwrite previous 
	-- reading the previous command variable - '@@'
	-- use XML:DB transactions where if something fails, I can roll back 


[DONE]	** --> 'Action' interfaces for:
[todo] a set of executed commands should be recorded in a shell (bean shell, rhino, -- none, custom shell). 
		  an implicit transaction
		[ok] CREATE
		[ok] ADD / REMOVE / REVERSE 
		[ok] UPDATE - figure out the syntax for this 
		** LOAD - implicit at system loading 
		[ok] FIND
		[ok] LIST
		** LOGIN - implement later 
		** LOGOUT - implement later 
		[ok] EXIT - implemented in the Bkell itself.
		
		
		** COMMIT save in memory XML to the database 
		modes: 
		autocommit (true/false); creating or updating an xml will only affect in memory XML unless this is set to true

[OK] tag PreAlpha bookkeeping
	[Projec-Version-Date]
	bookkeeping-PreAlpha-06082007

[OK] create 'bookkeeping' user 
[OK] System should start with a default system, users, bookkeeping/accounts/journals/transactions 

[OK] clean up DB access code to use configured credentials 
	- no explicit file referencing 
[OK] create a clean system initialisation procedure: Authentication, Bookkeeping System, Bkell 
	BookkeepingSystem -> Spittoon 
	Aauthorise 
[OK] introduce many currencies; a currency can only balance against itself
[OK] refactor Account / Journal debit and credit to be pointers to a separate node 
[DONE] > Authentication & Authorisation code
	[x] separate servlet to handle authentication, adding and removing of users 
	[~] SAML / Federated 
	- make it thread-enabled 
	
[OK] REFACTOR XMLs to use new 'bookkeeping.system.xml' model - bookkeeping books will be kept in groups!!! 

	(make interfaces)
[DONE] refactor actions to all use Action interface; and all Actions use Authetication and Authorisation 
	code. Authentication and Authorisation code should use a Mediator pattern where an Action adapter or 
	client (webkell, servlets; bkell, shell/SableCC) call Actions though the Mediator. The Mediator 
	would authenticate and authorise the calling code. 
	
	[x] remove the idea of a commit when adding / updating. Just add debit / credit to an entry. 
 	- a separate servlet will control the authentication, adding and removing of users; 
 	authentication / authorisation information is transfered to client 
	
	- with authentication / authorisation information in the servlet client, the client can handle 
	session, and authorisation rules. Those rules should be discarded at the end of the servlet's lifecycle.
	
	-- test for DB update / retrieval for a given user 
	
	- new commands must be created in bkeeping/bkell to 
		1. run the shell as a particular user or 
		2. login / logout as a particular user 

[DONE]  have SableCC code call updated Action interface 
	** Put Aauthentication into these places 

[OK] 	Free Java Hosting service 
		- myservlet.com
		- 4java.ca 
[OK] 	SableCC
		-- unit tests for DSL code
		[x] upgrade to SabelCC 4
			- Sablecc end of expression parsing; getting rid of EOF (SSableCC 4)
			- having shell take input (for history, etc), forward it to lexer
				- map the newline to EOF
				- make newline an expresion terminal 
				[x] wait for SableCC4
[OK]- bkell functional tests
		- webkell functional tests 

[X] auto-commit on/off 
	auto commit on commands: 
		add, create, remove, reverse 
	set auto-complete variable in the bkell environment; everytime a command is run, 
		[OK] it puts the result as a variable in the shell 
		- it is auto-committed if applicable 
	** we don't necessarily want the entire bookkeeping system in memory, so load and save only chunks of XML 

[OK] PERSISTENCE LAYER; 'Something' that figures out the persistent lifecycle of my objects
	** hardcoding it for now. 
    i) connection pooling
    ii) object mapping
    iii) transaction management

[OK] 	Store data online / offline ( locally ) 

[OK] web UI for bookkeeping
	- linkedIn, blog, email signatures, facebook, skype, ycombinator 
	* links: donation, tell a friend 
	
	** what 'look' do I want; 
		- very simple gmail-like vertical tabs ( www.gmail.com ) 
		- simple information organisation & colour scheme ( del.icio.us ) 
		- implicit, clean layout ( www.alistapart.com, openrico.org, www.informationarchitects.jp )
	
	** error handling on bad input / balance
		use log4j

[x] XML encryption & password shadowing ; using SSL 



>>>>>>>>>>>>>>>>>>>> GOALS 

[x] Making a package for small businesses
[OK] make 'bookeeping' usable to the point of
	i) demonstration; proof of concept
	ii) giving potentials a toy to play with
	
	-> UI for 'entry'; add / find / update / reverse / delete
	-> installer that puts (eXist, laszlo, java, & bookkeeping) onto system
[OK] EXAMPLE journal entries for a year



>>>>>>>>>>>>>>>>>>>> SCRATCH...

*) javac -classpath /Applications/eXist/exist.jar:/Applications/eXist/exist-optional.jar:/System/Library/Frameworks/JavaVM.framework/Home/lib/dt.jar:/Applications/eXist/lib/core/xmldb.jar CreateResource.java 
*) java -classpath .:/Applications/eXist/exist.jar:/Applications/eXist/exist-optional.jar:/Applications/eXist/lib/core/xmlrpc-1.2-patched.jar:/System/Library/Frameworks/JavaVM.framework/Home/lib/dt.jar:/Applications/eXist/lib/core/xmldb.jar CreateResource /db/bookkeeping/ data/buyequipment.xml 
*) for (Iterator it = allMovies.iterator(); it.hasNext();) {


